<html><head>
        <title>Javascript Exemplo Agenda</title>
    </head>
    <body>


        <style type="text/css">

            .filtro{
                background-color:  #6059ca;
                color : #FFFFFF ; 
                font-weight: bold ;
            }

        </style>


        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>

        <script>

            //Manipular a tabela
            function remover(id) {

                if (!isEditando()) {
                    var linha = document.getElementById(id);
                    linha.remove();
                } else {
                    alert('Favor finalizar a edição antes de remover!');
                }

            }

            function editar(id) {

                if (!isEditando()) {

                    var linha = document.getElementById(id);
                    linha.id = 'Editando';


                    var nome = linha.cells[1].innerHTML;
                    var telefone = linha.cells[2].innerHTML;

                    setNome(nome);
                    setTelefone(telefone);

                }



            }

            function setNome(nome) {
                document.getElementById('txtNome').value = nome;
            }

            function getNome() {

                return document.getElementById('txtNome').value;
            }

            function setTelefone(telefone) {
                document.getElementById('txtTelefone').value = telefone;
            }

            function getTelefone() {
                return document.getElementById('txtTelefone').value;
            }

            function inserir() {

                // peguei os inputs somente
                //debugger ; 
                //pegando os valores do campo
                var nome = getNome();
                var telefone = getTelefone();

                //pegar tabela 
                var tabela = document.getElementById('contatos');

                //per ultimo codigo tamanho de linhas 
                var id = tabela.rows.length;


                //criar linha 
                var linha = tabela.insertRow();
                linha.id = id;


                //criar celular 
                var celulaId = linha.insertCell(0);
                var celulaNome = linha.insertCell(1);
                var celulaTelefone = linha.insertCell(2);
                var celulaAcoes = linha.insertCell(3);

                var botaoEditar = '<input type="button" value="Editar" onclick="editar(\'' + id + '\');" />';
                var botaoRemover = '<input type="button" value="Remover" onclick="remover(\'' + id + '\');" />';

                //preencher celulas 
                celulaId.innerHTML = id;
                celulaNome.innerHTML = nome;
                celulaTelefone.innerHTML = telefone;
                celulaAcoes.innerHTML = botaoEditar + botaoRemover;

            }

            function atualizar() {

                //pregar as alterações feitas 
                var inputNome = document.getElementById('txtNome');
                var inputTelefone = document.getElementById('txtTelefone');

                var nome = inputNome.value;
                var telefone = inputTelefone.value;
                var linhaEditada = document.getElementById('Editando');

                linhaEditada.cells[1].innerHTML = nome;
                linhaEditada.cells[2].innerHTML = telefone;

                finalizarEdicao();


            }

            function finalizarEdicao() {
                var linhaEditada = document.getElementById('Editando');
                var id = linhaEditada.cells[0].innerHTML;
                linhaEditada.id = id;
            }

            function cancelar() {
                finalizarEdicao();
                limpar();


            }

            function isEditando() {
                return document.getElementById('Editando') != null;
            }

            function salvar() {

                //debugger ; 

                if (isPreenchido()) {

                    if (!isEditando()) {
                        inserir();
                    } else {
                        atualizar();
                    }

                    limpar();
                } else {

                    alert('Favor preencher os campos !');

                }





            }

            function limpar() {

                var inputNome = document.getElementById('txtNome');
                var inputTelefone = document.getElementById('txtTelefone');

                inputNome.value = '';
                inputTelefone.value = '';


            }

            function isPreenchido() {

                var inputNome = document.getElementById('txtNome');
                var inputTelefone = document.getElementById('txtTelefone');

                /// utilizar trim em strings para remover os espacos da esquerda e direita
                return inputNome.value.trim() != '' && inputTelefone.value.trim() != '';


            }



            // pesquisar na tabela 

            function pesquisarCodigo() {
                //Limpar a tabela 

                limparTabela();

                //pegar o valor do campo pesquisado
                //debugger  ; 
                var inputPesquisaCodigo = document.getElementById('txtPesquisaCodigo');
                var codigo = inputPesquisaCodigo.value;


                //colorir a linha 
                var linnhaProcurada = document.getElementById(codigo);
                if (linnhaProcurada != null) {
                    marcarLinha(linnhaProcurada);
                } else {
                    alert('Codigo não encontrado !')
                }

            }

            function marcarLinha(linha) {


                $(linha).addClass('filtro');

            }

            function limparTabela() {

                $('.filtro').removeClass();
                $('.hide').show().removeClass();
                var tabela = document.getElementById('contatos');
                var linhas = tabela.rows;

                for (var i = 0; i < linhas.length; i++) {
                    linhas[i].style.backgroundColor = '';
                    linhas[i].style.color = '';
                    linhas[i].style.fontWeight = '';
                    //linha.classList.remove("filtro");
                }


            }


            function pesquisarNome() {

                limparTabela();

                var tabela = document.getElementById('contatos');
                var linhas = tabela.rows;
                var inputPesquisaNome = document.getElementById('txtPesquisaNome');
                var nome = inputPesquisaNome.value;

                for (var i = 0; i < linhas.length; i++) {

                    if (linhas[i].cells[1].innerHTML.toUpperCase() == nome.toUpperCase()) {
                        marcarLinha(linhas[i]);
                    }


                }





            }

            function pesquisar() {

                limparTabela();

                //pegar os elementos 
                var tabela = document.getElementById('contatos');
                var linhas = tabela.rows;
                var codigo = document.getElementById('txtPesquisaCodigo').value.trim();
                var nome = document.getElementById('txtPesquisaNome').value.trim();

                if(codigo != '' || nome != '' ){

                //debugger ; 
                for (var i = 1; i < linhas.length; i++) {

                    //console.log('codigo:' + linhas[i].cells[0].innerHTML)	 ; 
                    //console.log('nome:' + linhas[i].cells[2].innerHTML );



                    if ((codigo != '' && codigo == linhas[i].cells[0].innerHTML && nome == '')
                            || (nome != '' && nome.toUpperCase() == linhas[i].cells[1].innerHTML.toUpperCase() && codigo == '')
                            || ((codigo != '' && codigo == linhas[i].cells[0].innerHTML) && (nome != '' && nome.toUpperCase() == linhas[i].cells[1].innerHTML.toUpperCase()))
                            )
                    {
                        marcarLinha(linhas[i]);
                    }else{
                        $(linhas[i]).addClass('hide');
                    }





                }


                $('.hide').hide();
                
        }else{
            limparTabela();
        }

                /*
                 if((isPreenchido(codigo) &&  equals(codigo , linhas[i].cells[0])&& !isPreenchido(nome) 
                 //codigo == linhas[i].cells[0].innerHTML && nome == '') 
                 || (nome != ''  && nome.toUpperCase() == linhas[i].cells[1].innerHTML.toUpperCase() && codigo == '')
                 || ((codigo != '' && codigo == linhas[i].cells[0].innerHTML  ) && ( nome != '' && nome.toUpperCase() == linhas[i].cells[1].innerHTML.toUpperCase())  )	
                 )	
                 {
                 marcarLinha(linhas[i]);
                 }
                 
                 
                 
                 
                 
                 }
                 */

            }

            function isPreenchido(valor) {
                return valor != '';
            }

            function equals(valor, valorCelula) {
                // codigo == linhas[i].cells[0].innerHTML
                return valor == valorCelula.innerHTML;

            }

            function equals2(valor, linha, numero) {
                // codigo == linhas[i].cells[0].innerHTML
                return valor == linha.cells[numero].innerHTML;

            }






        </script>
        <h2>Agenda</h2>

        <table  >

            <tr> 
                <td>
                    Nome:
                </td>
                <td>
                    <input style="width : 150px;" type="text" id="txtNome"  />
                </td>
                <td>
                    Telefone:
                </td>
                <td>
                    <input style="width : 100px;" type="text" id="txtTelefone"  />
                </td>
                <td>
                    <input type="button" value="Salvar" onclick="salvar();"/>
                </td>
                <td>
                    <input type="button" value="Cancelar" onclick="cancelar();"/>
                </td>
            <tr>
        </table>
        <br />
        <fieldset>

            <legend>Contatos</legend>

            <fieldset>
                <legend>Pesquisar</legend>

                <table width='500px'>
                    <tr>
                        <td width='10px'>
                            Código:
                        </td>
                        <td >
                            <input type="text" id="txtPesquisaCodigo" style="width : 50px;" />
                        </td>
                        <td>
                            Nome:
                        </td>
                        <td>
                            <input type="text" id="txtPesquisaNome" style="width : 260px;" /> 
                        </td>
                        <td>
                            <!-- 
                            <input type="button" value="Pesquisar Codigo " onclick="pesquisarCodigo();" />  
                            <input type="button" value="Pesquisar Nome " onclick="pesquisarNome();" /> 
                            -->

                            <input type="button" value="Pesquisar" onclick="pesquisar();" /> 
                        </td>
                    </tr>
                </table>

            </fieldset>


            <fieldset>
                <legend>Lista de Contatos</legend>
                <table  width='500px' id="contatos" border="1">
                    <tr id="titulo" >
                        <td width='10px'>
                            Código
                        </td>
                        <td>
                            Nome
                        </td>
                        <td>
                            Telefone
                        </td>
                        <td style="width: 125px; text-align: right;"></td>
                    </tr>

                </table>
            </fieldset>

        </fieldset








    </body>

</html>















